
.386p

        NAME    A_X

        .model small, c

DGROUP  GROUP   _DATA


_DATA   SEGMENT DWORD PUBLIC USE32 'DATA'

EXTERN  _XVGA_columns : dword

_DATA   ENDS



_TEXT   SEGMENT BYTE PUBLIC USE32 'CODE'
                ASSUME  CS:_TEXT ,DS:DGROUP,SS:DGROUP

PUBLIC  _X256_movPlane
PUBLIC  _X256_movPlane2
PUBLIC  _X256_getPlane
PUBLIC  _X256_movPlaneSpr
PUBLIC  _X256_movPlaneSpr2

XPUT4   MACRO
LOCAL   XP_p4l
XP_p4l:
        mov     al,[esi]
        add     esi,4
        mov     ah,[esi]
        add     esi,4
        ror     eax,16
        mov     al,[esi]
        add     esi,4
        mov     ah,[esi]
        add     esi,4
        ror     eax,16
        stosd
        dec     ecx
        jne     XP_p4l
        ENDM

XPREST3  MACRO
        mov     al,[esi]
        mov     ah,[esi+4]
        mov     [edi],ax
        mov     al,[esi+8]
        mov     [edi+2],al
        ENDM

XPREST2  MACRO
        mov     al,[esi]
        mov     ah,[esi+4]
        mov     [edi],ax
        ENDM

XPREST1  MACRO
        mov     al,[esi]
        mov     [edi],al
        ENDM


_X256_movPlane  PROC USES esi edi eax ebx ecx edx,
        dst     : dword, src     : dword,
        sizeX   : dword, sizeY   : dword, formatX  : dword

        LOCAL   dstFormatX : dword

        mov     ecx,sizeX
        mov     edx,sizeY
        mov     edi,dst
        mov     esi,src
        or      edx,edx
        je      XP_end
        mov     eax,_XVGA_columns
        mov     ebx,eax
        mov     eax,ecx
        and     eax,0xFFFFFFFC
        sub     ebx,eax
        mov     dstFormatX,ebx
        shl     eax,2
        sub     formatX,eax
        mov     eax,ecx
        shr     ecx,2
        mov     ebx,ecx
        je      XP_rest
        and     eax,3
        je      XP_p4
        dec     eax
        je      XP_p1
        dec     eax
        je      XP_p2
        jmp     XP_p3

XP_p4:
        XPUT4
        mov     ecx,ebx
        add     esi,formatX
        add     edi,dstFormatX
        dec     edx
        jne     XP_p4
        jmp     XP_end

XP_p3:
        XPUT4
        XPREST3
        mov     ecx,ebx
        add     esi,formatX
        add     edi,dstFormatX
        dec     edx
        jne     XP_p3
        jmp     XP_end

XP_p2:
        XPUT4
        XPREST2
        mov     ecx,ebx
        add     esi,formatX
        add     edi,dstFormatX
        dec     edx
        jne     XP_p2
        jmp     XP_end

XP_p1:
        XPUT4
        XPREST1
        mov     ecx,ebx
        add     esi,formatX
        add     edi,dstFormatX
        dec     edx
        jne     XP_p1
        jmp     XP_end

XP_rest:
        and     eax,3
        je      XP_end
        mov     ebx,dstFormatX
        mov     ecx,formatX
        dec     eax
        je      XP_r1
        dec     eax
        je      XP_r2
        jmp     XP_r3

XP_r3:
        XPREST3
        add     esi,ecx
        add     edi,ebx
        dec     edx
        jne     XP_r3
        jmp     XP_end

XP_r1:
        XPREST1
        add     esi,ecx
        add     edi,ebx
        dec     edx
        jne     XP_r1
        jmp     XP_end

XP_r2:
        XPREST2
        add     esi,ecx
        add     edi,ebx
        dec     edx
        jne     XP_r2
        jmp     XP_end

XP_end:
        ret

_X256_movPlane  ENDP






X2PUT4   MACRO
LOCAL   X2P_p4l
X2P_p4l:
        mov     al,[esi]
        add     esi,4
        mov     ah,[esi]
        add     esi,4
        ror     eax,16
        mov     al,[esi]
        add     esi,4
        mov     ah,[esi]
        add     esi,4
        ror     eax,16
        stosd
        mov     [ebx],eax
        add     ebx,4
        dec     ecx
        jne     X2P_p4l
        ENDM

X2REST3  MACRO
        mov     al,[esi]
        mov     ah,[esi+4]
        mov     [edi],ax
        mov     [ebx],ax
        mov     al,[esi+8]
        mov     [edi+2],al
        mov     [ebx+2],al
        ENDM

X2REST2  MACRO
        mov     al,[esi]
        mov     ah,[esi+4]
        mov     [edi],ax
        mov     [ebx],ax
        ENDM

X2REST1  MACRO
        mov     al,[esi]
        mov     [edi],al
        mov     [ebx],al
        ENDM


_X256_movPlane2 PROC USES esi edi eax ebx ecx edx,
        dst     : dword, dst2    : dword, src      : dword,
        sizeX   : dword, sizeY   : dword, formatX  : dword

        LOCAL   dstFormatX : dword

        mov     ecx,sizeX
        mov     edx,sizeY
        mov     edi,dst
        mov     esi,src
        or      edx,edx
        je      X2P_end
        mov     eax,_XVGA_columns
        mov     ebx,eax
        mov     eax,ecx
        and     eax,0xFFFFFFFC
        sub     ebx,eax
        mov     dstFormatX,ebx
        shl     eax,2
        sub     formatX,eax
        mov     eax,ecx
        shr     ecx,2
        mov     sizeX,ecx
        mov     ebx,dst2
        je      X2P_rest
        and     eax,3
        je      X2P_p4
        dec     eax
        je      X2P_p1
        dec     eax
        je      X2P_p2
;        dec     eax
;        je      X2P_p3
;        jmp     X2P_end
         jmp     X2P_p3

X2P_p4:
        X2PUT4
        mov     ecx,sizeX
        add     esi,formatX
        mov     eax,dstFormatX
        add     edi,eax
        add     ebx,eax
        dec     edx
        jne     X2P_p4
        jmp     X2P_end

X2P_p3:
        X2PUT4
        X2REST3
        mov     ecx,sizeX
        add     esi,formatX
        mov     eax,dstFormatX
        add     edi,eax
        add     ebx,eax
        dec     edx
        jne     X2P_p3
        jmp     X2P_end

X2P_p2:
        X2PUT4
        X2REST2
        mov     ecx,sizeX
        add     esi,formatX
        mov     eax,dstFormatX
        add     edi,eax
        add     ebx,eax
        dec     edx
        jne     X2P_p2
        jmp     X2P_end

X2P_p1:
        X2PUT4
        X2REST1
        mov     ecx,sizeX
        add     esi,formatX
        mov     eax,dstFormatX
        add     edi,eax
        add     ebx,eax
        dec     edx
        jne     X2P_p1
        jmp     X2P_end

X2P_rest:
        and     eax,3
        je      X2P_end
        push    ebp
        mov     ecx,formatX
        mov     ebp,dstFormatX
        dec     eax
        je      X2P_r1
        dec     eax
        je      X2P_r2
        jmp     X2P_r3

X2P_r3:
        X2REST3
        add     esi,ecx
        add     edi,ebp
        add     ebx,ebp
        dec     edx
        jne     X2P_r3
        jmp     X2P_pop

X2P_r1:
        X2REST1
        add     esi,ecx
        add     edi,ebp
        add     ebx,ebp
        dec     edx
        jne     X2P_r1
        jmp     X2P_pop

X2P_r2:
        X2REST2
        add     esi,ecx
        add     edi,ebp
        add     ebx,ebp
        dec     edx
        jne     X2P_r2
        jmp     X2P_pop
X2P_pop:
        pop     ebp
X2P_end:
        ret

_X256_movPlane2 ENDP



XGET4   MACRO
LOCAL   XP_p4l
XP_p4l:
        lodsd
        mov     [edi],al
        add     edi,4
        mov     [edi],ah
        add     edi,4
        ror     eax,16
        mov     [edi],al
        add     edi,4
        mov     [edi],ah
        add     edi,4
        dec     ecx
        jne     XP_p4l
        ENDM

XGREST3  MACRO
        mov     eax,[esi]
        mov     [edi],al
        mov     [edi+4],ah
        shr     eax,8
        mov     [edi+8],ah
        ENDM

XGREST2  MACRO
        mov     ax,[esi]
        mov     [edi],al
        mov     [edi+4],ah
        ENDM

XGREST1  MACRO
        mov     al,[esi]
        mov     [edi],al
        ENDM


_X256_getPlane  PROC USES esi edi eax ebx ecx edx,
        dst     : dword, src     : dword,
        sizeX   : dword, sizeY   : dword, formatX  : dword

        LOCAL   dstFormatX : dword

        mov     ecx,sizeX
        mov     edx,sizeY
        mov     edi,src
        mov     esi,dst
        or      edx,edx
        je      XG_end
        mov     eax,_XVGA_columns
        mov     ebx,eax
        mov     eax,ecx
        and     eax,0xFFFFFFFC
        sub     ebx,eax
        mov     dstFormatX,ebx
        shl     eax,2
        sub     formatX,eax
        mov     eax,ecx
        shr     ecx,2
        mov     ebx,ecx
        je      XG_rest
        and     eax,3
        je      XG_p4
        dec     eax
        je      XG_p1
        dec     eax
        je      XG_p2
        jmp     XG_p3

XG_p4:
        XGET4
        mov     ecx,ebx
        add     edi,formatX
        add     esi,dstFormatX
        dec     edx
        jne     XG_p4
        jmp     XG_end

XG_p3:
        XGET4
        XGREST3
        mov     ecx,ebx
        add     edi,formatX
        add     esi,dstFormatX
        dec     edx
        jne     XG_p3
        jmp     XG_end

XG_p2:
        XGET4
        XGREST2
        mov     ecx,ebx
        add     edi,formatX
        add     esi,dstFormatX
        dec     edx
        jne     XG_p2
        jmp     XG_end

XG_p1:
        XGET4
        XGREST1
        mov     ecx,ebx
        add     edi,formatX
        add     esi,dstFormatX
        dec     edx
        jne     XG_p1
        jmp     XG_end

XG_rest:
        and     eax,3
        je      XG_end
        mov     ebx,dstFormatX
        mov     ecx,formatX
        dec     eax
        je      XG_r1
        dec     eax
        je      XG_r2
        jmp     XG_r3

XG_r3:
        XGREST3
        add     edi,ecx
        add     esi,ebx
        dec     edx
        jne     XG_r3
        jmp     XG_end

XG_r1:
        XGREST1
        add     edi,ecx
        add     esi,ebx
        dec     edx
        jne     XG_r1
        jmp     XG_end

XG_r2:
        XGREST2
        add     edi,ecx
        add     esi,ebx
        dec     edx
        jne     XG_r2
        jmp     XG_end

XG_end:
        ret

_X256_getPlane  ENDP


XSPUT4   MACRO
LOCAL   XSP_p4l
XSP_p4l:
LOCAL XSP_skip4, XSP_d1, XSP_d2, XSP_d3, XSP_d4
LOCAL XSP_n1, XSP_n2, XSP_n3, XSP_n4, XSP_next

        mov     al,[esi]
        add     esi,4
        mov     ah,[esi]
        add     esi,4
        ror     eax,16
        mov     al,[esi]
        add     esi,4
        mov     ah,[esi]
        add     esi,4
        ror     eax,16

        or      eax,eax
        je      XSP_skip4
        mov     edx,eax
        shr     edx,16
        or      al,al
        je      XSP_d1
        or      ah,ah
        je      XSP_d2
        or      dl,dl
        je      XSP_d3
        or      dh,dh
        je      XSP_d4
        mov     es:[edi],eax
XSP_skip4:
        add     edi,4
        jmp     XSP_next
XSP_d1:
        inc     edi
        jmp     XSP_n1
XSP_d2:
        stosb
        jmp     XSP_n2
XSP_d3:
        stosw
        jmp     XSP_n3
XSP_d4:
        stosw
        mov     es:[edi],dl
        inc     edi
        jmp     XSP_n4
XSP_n1:
        or      ah,ah
        je      XSP_n2
        mov     es:[edi],ah
XSP_n2:
        inc     edi
        or      dl,dl
        je      XSP_n3
        mov     es:[edi],dl
XSP_n3:
        inc     edi
        or      dh,dh
        je      XSP_n4
        mov     es:[edi],dh
XSP_n4:
        inc     edi
XSP_next:
        dec     ecx
        jne     XSP_p4l
        ENDM

XSPREST3  MACRO
LOCAL   XSP_rest1, XSP_rest2, XSP_rest3, XSP_rest4
        mov     al,[esi]
XSP_rest1:
        or      al,al
        je      XSP_rest2
        mov     es:[edi],al
XSP_rest2:
        mov     al,[esi+4]
        or      al,al
        je      XSP_rest3
        mov     es:[edi+1],al
XSP_rest3:
        mov     al,[esi+8]
        or      al,al
        je      XSP_rest4
        mov     es:[edi+2],al
XSP_rest4:
        ENDM

XSPREST2  MACRO
LOCAL   XSP_rest1, XSP_rest2, XSP_rest3
        mov     al,[esi]
XSP_rest1:
        or      al,al
        je      XSP_rest2
        mov     es:[edi],al
XSP_rest2:
        mov     al,[esi+4]
        or      al,al
        je      XSP_rest3
        mov     es:[edi+1],al
XSP_rest3:
        ENDM

XSPREST1  MACRO
LOCAL   XSP_rest1, XSP_rest2
        mov     al,[esi]
XSP_rest1:
        or      al,al
        je      XSP_rest2
        mov     es:[edi],al
XSP_rest2:
        ENDM


_X256_movPlaneSpr  PROC USES esi edi eax ebx ecx edx,
        dst     : dword, src     : dword,
        sizeX   : dword, sizeY   : dword, formatX  : dword

        LOCAL   dstFormatX : dword

        mov     ecx,sizeX
        mov     ebx,sizeY
        mov     edi,dst
        mov     esi,src
        or      ebx,ebx
        je      XSP_end
        mov     eax,_XVGA_columns
        mov     edx,eax
        mov     eax,ecx
        and     eax,0xFFFFFFFC
        sub     edx,eax
        mov     dstFormatX,edx
        shl     eax,2
        sub     formatX,eax
        mov     eax,ecx
        shr     ecx,2
        mov     sizeX,ecx
        je      XSP_rest
        and     eax,3
        je      XSP_p4
        dec     eax
        je      XSP_p1
        dec     eax
        je      XSP_p2
        jmp     XSP_p3

XSP_p4:
        XSPUT4
        mov     ecx,sizeX
        add     esi,formatX
        add     edi,dstFormatX
        dec     ebx
        jne     XSP_p4
        jmp     XSP_end

XSP_p3:
        XSPUT4
        XSPREST3
        mov     ecx,sizeX
        add     esi,formatX
        add     edi,dstFormatX
        dec     ebx
        jne     XSP_p3
        jmp     XSP_end

XSP_p2:
        XSPUT4
        XSPREST2
        mov     ecx,sizeX
        add     esi,formatX
        add     edi,dstFormatX
        dec     ebx
        jne     XSP_p2
        jmp     XSP_end

XSP_p1:
        XSPUT4
        XSPREST1
        mov     ecx,sizeX
        add     esi,formatX
        add     edi,dstFormatX
        dec     ebx
        jne     XSP_p1
        jmp     XSP_end

XSP_rest:
        and     eax,3
        je      XSP_end
        push    ebp
        mov     ecx,formatX
        mov     ebp,dstFormatX
        dec     eax
        je      XSP_r1
        dec     eax
        je      XSP_r2
        jmp     XSP_r3

XSP_r3:
        XSPREST3
        add     esi,ecx
        add     edi,ebp
        dec     ebx
        jne     XSP_r3
        jmp     XSP_pop

XSP_r1:
        XSPREST1
        add     esi,ecx
        add     edi,ebp
        dec     ebx
        jne     XSP_r1
        jmp     XSP_pop

XSP_r2:
        XSPREST2
        add     esi,ecx
        add     edi,ebp
        dec     ebx
        jne     XSP_r2
        jmp     XSP_pop

XSP_pop:
        pop    ebp

XSP_end:
        ret

_X256_movPlaneSpr  ENDP



XS2PUT4   MACRO
LOCAL   XS2P_p4l
XS2P_p4l:
LOCAL XS2P_skip4, XS2P_d1, XS2P_d2, XS2P_d3, XS2P_d4
LOCAL XS2P_n1, XS2P_n2, XS2P_n3, XS2P_n4, XS2P_next

        mov     al,[esi]
        add     esi,4
        mov     ah,[esi]
        add     esi,4
        ror     eax,16
        mov     al,[esi]
        add     esi,4
        mov     ah,[esi]
        add     esi,4
        ror     eax,16

        or      eax,eax
        je      XS2P_skip4
        mov     edx,eax
        shr     edx,16
        or      al,al
        je      XS2P_d1
        or      ah,ah
        je      XS2P_d2
        or      dl,dl
        je      XS2P_d3
        or      dh,dh
        je      XS2P_d4
        mov     es:[edi],eax
        mov     es:[ebx],eax
XS2P_skip4:
        add     edi,4
        add     ebx,4
        jmp     XS2P_next
XS2P_d1:
        inc     edi
        inc     ebx
        jmp     XS2P_n1
XS2P_d2:
        stosb
        mov     es:[ebx],al
        inc     ebx
        jmp     XS2P_n2
XS2P_d3:
        stosw
        mov     es:[ebx],ax
        add     ebx,2
        jmp     XS2P_n3
XS2P_d4:
        stosw
        mov     es:[ebx],ax
        add     ebx,2
        mov     es:[edi],dl
        mov     es:[ebx],dl
        inc     edi
        inc     ebx
        jmp     XS2P_n4
XS2P_n1:
        or      ah,ah
        je      XS2P_n2
        mov     es:[edi],ah
        mov     es:[ebx],ah
XS2P_n2:
        inc     edi
        inc     ebx
        or      dl,dl
        je      XS2P_n3
        mov     es:[edi],dl
        mov     es:[ebx],dl
XS2P_n3:
        inc     edi
        inc     ebx
        or      dh,dh
        je      XS2P_n4
        mov     es:[edi],dh
        mov     es:[ebx],dh
XS2P_n4:
        inc     edi
        inc     ebx
XS2P_next:
        dec     ecx
        jne     XS2P_p4l
        ENDM

XS2PREST3  MACRO
LOCAL   XS2P_rest1, XS2P_rest2, XS2P_rest3, XS2P_rest4
        mov     al,[esi]
XS2P_rest1:
        or      al,al
        je      XS2P_rest2
        mov     es:[edi],al
        mov     es:[ebx],al
XS2P_rest2:
        mov     al,[esi+4]
        or      al,al
        je      XS2P_rest3
        mov     es:[edi+1],al
        mov     es:[ebx+1],al
XS2P_rest3:
        mov     al,[esi+8]
        or      al,al
        je      XS2P_rest4
        mov     es:[edi+2],al
        mov     es:[ebx+2],al
XS2P_rest4:
        ENDM

XS2PREST2  MACRO
LOCAL   XS2P_rest1, XS2P_rest2, XS2P_rest3
        mov     al,[esi]
XS2P_rest1:
        or      al,al
        je      XS2P_rest2
        mov     es:[edi],al
        mov     es:[ebx],al
XS2P_rest2:
        mov     al,[esi+4]
        or      al,al
        je      XS2P_rest3
        mov     es:[edi+1],al
        mov     es:[ebx+1],al
XS2P_rest3:
        ENDM

XS2PREST1  MACRO
LOCAL   XS2P_rest1, XS2P_rest2
        mov     al,[esi]
XS2P_rest1:
        or      al,al
        je      XS2P_rest2
        mov     es:[edi],al
        mov     es:[ebx],al
XS2P_rest2:
        ENDM


_X256_movPlaneSpr2  PROC USES esi edi eax ebx ecx edx,
        dst     : dword, dst2    : dword, src     : dword,
        sizeX   : dword, sizeY   : dword, formatX  : dword

        LOCAL   dstFormatX : dword

        mov     ecx,sizeX
        cmp     sizeY,0
        je      XS2P_end
        mov     edi,dst
        mov     esi,src
        mov     ebx,dst2
        mov     eax,_XVGA_columns
        mov     edx,eax
        mov     eax,ecx
        and     eax,0xFFFFFFFC
        sub     edx,eax
        mov     dstFormatX,edx
        shl     eax,2
        sub     formatX,eax
        mov     eax,ecx
        shr     ecx,2
        mov     sizeX,ecx
        je      XS2P_rest
        and     eax,3
        je      XS2P_p4
        dec     eax
        je      XS2P_p1
        dec     eax
        je      XS2P_p2
        jmp     XS2P_p3

XS2P_p4:
        XS2PUT4
        mov     ecx,sizeX
        add     esi,formatX
        mov     eax,dstFormatX
        add     edi,eax
        add     ebx,eax
        dec     sizeY
        jne     XS2P_p4
        jmp     XS2P_end

XS2P_p3:
        XS2PUT4
        XS2PREST3
        mov     ecx,sizeX
        add     esi,formatX
        mov     eax,dstFormatX
        add     edi,eax
        add     ebx,eax
        dec     sizeY
        jne     XS2P_p3
        jmp     XS2P_end

XS2P_p2:
        XS2PUT4
        XS2PREST2
        mov     ecx,sizeX
        add     esi,formatX
        mov     eax,dstFormatX
        add     edi,eax
        add     ebx,eax
        dec     sizeY
        jne     XS2P_p2
        jmp     XS2P_end

XS2P_p1:
        XS2PUT4
        XS2PREST1
        mov     ecx,sizeX
        add     esi,formatX
        mov     eax,dstFormatX
        add     edi,eax
        add     ebx,eax
        dec     sizeY
        jne     XS2P_p1
        jmp     XS2P_end

XS2P_rest:
        and     eax,3
        je      XS2P_end
        mov     ecx,sizeY
        dec     eax
        je      XS2P_r1
        dec     eax
        je      XS2P_r2
        jmp     XS2P_r3

XS2P_r3:
        XS2PREST3
        add     esi,formatX
        mov     eax,dstFormatX
        add     edi,eax
        add     ebx,eax
        dec     ecx
        jne     XS2P_r3
        jmp     XS2P_end

XS2P_r1:
        XS2PREST1
        add     esi,formatX
        mov     eax,dstFormatX
        add     edi,eax
        add     ebx,eax
        dec     ecx
        jne     XS2P_r1
        jmp     XS2P_end

XS2P_r2:
        XS2PREST2
        add     esi,formatX
        mov     eax,dstFormatX
        add     edi,eax
        add     ebx,eax
        dec     ecx
        jne     XS2P_r2
        jmp     XS2P_end

XS2P_end:
        ret

_X256_movPlaneSpr2  ENDP


_TEXT   ENDS
                END
