
.386p

        NAME    A_DITH

        .model small, c

DGROUP  GROUP   _DATA


_DATA   SEGMENT DWORD PUBLIC USE32 'DATA'

EXTERN  _DITH_shadeBuf : dword

_DATA   ENDS

PUBLIC  _DITH_shadeMask
PUBLIC  _DITH_shadeRaw
PUBLIC  _DITH_shadeMap

shadeMap4       MACRO
LOCAL   move,next
move:
        mov     eax,[edi] ; eax = sprite to shade
        mov     edx,[esi] ; edx = mask
        add     esi,4
        or      edx,edx
        je      next
        mov     bh,dl
        mov     bl,al
        mov     al,[ebx]
        mov     bh,dh
        mov     bl,ah
        mov     ah,[ebx]
        ror     eax,16
        ror     edx,16
        mov     bh,dl
        mov     bl,al
        mov     al,[ebx]
        mov     bh,dh
        mov     bl,ah
        mov     ah,[ebx]
        ror     eax,16
next:
        mov     es:[ebp],eax
        add     edi,4
        add     ebp,4
        dec     ecx
        jne     move
                ENDM

shadeMapR1      MACRO
        mov     bl,[esi]
        mov     bh,[edi]
        mov     bh,[ebx]
        mov     es:[ebp],bh
        inc     edi
                ENDM

shadeMapR2      MACRO
        mov     eax,[edi]
        mov     edx,[esi]
        mov     bh,dl
        mov     bl,al
        mov     al,[ebx]
        mov     bl,ah
        mov     bh,dh
        mov     ah,[ebx]
        mov     es:[ebp],ax
        add     edi,2
                ENDM

shadeMapR3      MACRO
        mov     eax,[edi]
        mov     edx,[esi]
        mov     bl,al
        mov     bh,dl
        mov     al,[ebx]
        mov     bl,ah
        mov     bh,dh
        mov     ah,[ebx]
        mov     es:[ebp],ax
        add     edi,3
        shr     eax,16
        shr     edx,16
        mov     bl,al
        mov     bh,dl
        mov     al,[ebx]
        mov     es:[ebp+2],al
                ENDM


_TEXT   SEGMENT BYTE PUBLIC USE32 'CODE'
                ASSUME  CS:_TEXT ,DS:DGROUP,SS:DGROUP

_DITH_shadeMap       PROC USES esi edi eax ebx ecx edx,
        raw        : dword, rawFormatX : dword,
        dst        : dword, dstFormatX : dword,
        spr        : dword,
        srcSizeX   : dword, srcSizeY   : dword

        LOCAL   sizeX : dword

        mov     ecx,srcSizeX
        mov     eax,ecx
        and     ecx,0ffffffffh-3
        sub     dstFormatX,ecx
        sub     rawFormatX,ecx
        mov     edi,spr
        mov     esi,raw
        mov     ebx,_DITH_shadeBuf
        shr     ecx,2
        mov     sizeX,ecx
        je      DTMP_rest

DTMP_move:
        and     eax,3
        je      DTMP_move0
        dec     eax
        je      DTMP_move1
        dec     eax
        je      DTMP_move2
        dec     eax
        jmp     DTMP_move3

DTMP_move0:
        or      eax,srcSizeY
        je      DTMP_ret
        cmp     ecx,1
        je      DTMP_move4

DTMP_move0l:
        push    ebp
        mov     ebp,dst
        shadeMap4
        mov     eax,ebp
        pop     ebp
        add     eax,dstFormatX
        mov     dst,eax

        add     esi,rawFormatX
        mov     ecx,sizeX

        dec     srcSizeY
        jne     DTMP_move0l
        jmp     DTMP_ret

DTMP_move1:
        or      eax,srcSizeY
        je      DTMP_ret
DTMP_move1l:
        push    ebp
        mov     ebp,dst
        shadeMap4
        shadeMapR1
        mov     eax,ebp
        pop     ebp
        add     eax,dstFormatX
        mov     dst,eax

        add     esi,rawFormatX
        mov     ecx,sizeX

        dec     srcSizeY
        jne     DTMP_move1l
        jmp     DTMP_ret

DTMP_move2:
        or      eax,srcSizeY
        je      DTMP_ret

DTMP_move2l:
        push    ebp
        mov     ebp,dst
        shadeMap4
        shadeMapR2
        mov     eax,ebp
        pop     ebp
        add     eax,dstFormatX
        mov     dst,eax

        add     esi,rawFormatX
        mov     ecx,sizeX
        dec     srcSizeY
        jne     DTMP_move2l
        jmp     DTMP_ret

DTMP_move3:
        or      eax,srcSizeY
        je      DTMP_ret
DTMP_move3l:
        push    ebp
        mov     ebp,dst
        shadeMap4
        shadeMapR3
        mov     eax,ebp
        pop     ebp
        add     eax,dstFormatX
        mov     dst,eax

        add     esi,rawFormatX
        mov     ecx,sizeX
        dec     srcSizeY
        jne     DTMP_move3l
        jmp     DTMP_ret

DTMP_move4:
        mov     ecx,eax
        add     rawFormatX,4
        add     dstFormatX,4
DTMP_move4l:
        push    ebp
        mov     ebp,dst
        mov     eax,[edi]
        mov     edx,[esi]
        mov     bh,dl
        mov     bl,al
        mov     al,[ebx]
        mov     bh,dh
        mov     bl,ah
        mov     ah,[ebx]
        ror     eax,16
        ror     edx,16
        mov     bl,al
        mov     bh,dl
        mov     al,[ebx]
        mov     bh,dh
        mov     bl,ah
        mov     ah,[ebx]
        ror     eax,16
        mov     es:[ebp],eax
        add     ebp,4
        mov     eax,ebp
        pop     ebp
        add     eax,dstFormatX
        mov     dst,eax

        add     esi,rawFormatX
        dec     ecx
        jne     DTMP_move4l

        jmp     DTMP_ret

DTMP_rest:
        and     eax,3
        je      DTMP_ret
        dec     eax
        je      DTMP_rest1
        dec     eax
        je      DTMP_rest2
        dec     eax
        jmp     DTMP_rest3

DTMP_rest1:
        or      eax,srcSizeY
        je      DTMP_ret

        mov     ecx,rawFormatX
        push    ebp
        mov     ebp,dst
DTMP_rest1l:
        mov     bl,[esi]
        mov     bh,[edi]
        mov     bh,[ebx]
        mov     es:[ebp],bh
        inc     edi
        add     esi,edx
        add     ebp,ecx
        dec     eax
        jne     DTMP_rest1l
        pop     ebp
        jmp     DTMP_ret

DTMP_rest2:
        or      eax,srcSizeY
        je      DTMP_ret
        mov     ecx,eax
DTMP_rest2l:
        push    ebp
        mov     ebp,dst
        shadeMapR2
        mov     eax,ebp
        pop     ebp
        add     eax,dstFormatX
        mov     dst,eax

        add     esi,rawFormatX

        dec     ecx
        jne     DTMP_rest2l
        jmp     DTMP_ret

DTMP_rest3:
        or      eax,srcSizeY
        je      DTMP_ret
        mov     ecx,eax
DTMP_rest3l:
        push    ebp
        mov     ebp,dst
        shadeMapR3
        mov     eax,ebp
        pop     ebp
        add     eax,dstFormatX
        mov     dst,eax

        add     esi,rawFormatX
        dec     ecx
        jne     DTMP_rest3l
        jmp     DTMP_ret
DTMP_ret:
        ret


_DITH_shadeMap  ENDP


shadeRaw4       MACRO
LOCAL   move,next
move:
        mov     eax,[edi] ; eax = sprite to shade
        mov     edx,[esi] ; edx = mask
        add     esi,4
        or      edx,edx
        je      next
        mov     bh,dl
        mov     bl,al
        mov     al,[ebx]
        mov     bh,dh
        mov     bl,ah
        mov     ah,[ebx]
        ror     eax,16
        ror     edx,16
        mov     bh,dl
        mov     bl,al
        mov     al,[ebx]
        mov     bh,dh
        mov     bl,ah
        mov     ah,[ebx]
        ror     eax,16
        mov     es:[edi],eax
next:
        add     edi,4
        dec     ecx
        jne      move
                ENDM

shadeRawR1      MACRO
        mov     bh,[esi]
        mov     bl,es:[edi]
        mov     bl,[ebx]
        mov     es:[edi],bl
                ENDM

shadeRawR2      MACRO
        mov     eax,es:[edi]
        mov     edx,[esi]
        mov     bh,dl
        mov     bl,al
        mov     al,[ebx]
        mov     bl,ah
        mov     bh,dh
        mov     ah,[ebx]
        mov     es:[edi],ax
                ENDM

shadeRawR3      MACRO
        mov     eax,es:[edi]
        mov     edx,[esi]
        mov     bl,al
        mov     bh,dl
        mov     al,[ebx]
        mov     bl,ah
        mov     bh,dh
        mov     ah,[ebx]
        mov     es:[edi],ax
        shr     eax,16
        shr     edx,16
        mov     bl,al
        mov     bh,dl
        mov     al,[ebx]
        mov     es:[edi+2],al
                ENDM


_DITH_shadeRaw       PROC USES esi edi eax ebx ecx edx,
        raw        : dword, rawFormatX : dword,
        dst        : dword, dstFormatX : dword,
        srcSizeX   : dword, srcSizeY   : dword

        LOCAL   sizeX : dword

        mov     ecx,srcSizeX
        mov     eax,ecx
        and     ecx,0ffffffffh-3
        sub     dstFormatX,ecx
        sub     rawFormatX,ecx
        mov     edi,dst
        mov     esi,raw
        mov     ebx,_DITH_shadeBuf
        shr     ecx,2
        mov     sizeX,ecx
        je      DTR_rest

DTR_move:
        and     eax,3
        je      DTR_move0
        dec     eax
        je      DTR_move1
        dec     eax
        je      DTR_move2
        dec     eax
        jmp     DTR_move3

DTR_move0:
        or      eax,srcSizeY
        je      DTR_ret
        cmp     ecx,1
        je      DTR_move4

DTR_move0l:
        shadeRaw4

        add     esi,rawFormatX
        mov     ecx,sizeX
        add     edi,dstFormatX

        dec     srcSizeY
        jne     DTR_move0l
        jmp     DTR_ret

DTR_move1:
        or      eax,srcSizeY
        je      DTR_ret
DTR_move1l:
        shadeRaw4
        shadeRawR1

        add     esi,rawFormatX
        mov     ecx,sizeX
        add     edi,dstFormatX

        dec     srcSizeY
        jne     DTR_move1l
        jmp     DTR_ret

DTR_move2:
        or      eax,srcSizeY
        je      DTR_ret

DTR_move2l:
        shadeRaw4
        shadeRawR2

        add     esi,rawFormatX
        mov     ecx,sizeX
        add     edi,dstFormatX
        dec     srcSizeY
        jne     DTR_move2l
        jmp     DTR_ret

DTR_move3:
        or      eax,srcSizeY
        je      DTR_ret
DTR_move3l:
        shadeRaw4
        shadeRawR3

        add     esi,rawFormatX
        mov     ecx,sizeX
        add     edi,dstFormatX
        dec     srcSizeY
        jne     DTR_move3l
        jmp     DTR_ret

DTR_move4:
        mov     ecx,eax
        add     rawFormatX,4
        add     dstFormatX,4
DTR_move4l:
        mov     eax,es:[edi]
        mov     edx,[esi]
        mov     bh,dl
        mov     bl,al
        mov     al,[ebx]
        mov     bh,dh
        mov     bl,ah
        mov     ah,[ebx]
        ror     eax,16
        ror     edx,16
        mov     bl,al
        mov     bh,dl
        mov     al,[ebx]
        mov     bh,dh
        mov     bl,ah
        mov     ah,[ebx]
        ror     eax,16
        add     esi,rawFormatX
        mov     es:[edi],eax
        add     edi,dstFormatX
        dec     ecx
        jne     DTR_move4l
        jmp     dtr_ret

DTR_rest:
        and     eax,3
        je      DTR_ret
        dec     eax
        je      DTR_rest1
        dec     eax
        je      DTR_rest2
        dec     eax
        jmp     DTR_rest3

DTR_rest1:
        or      eax,srcSizeY
        je      DTR_ret

        mov     ecx,rawFormatX
        mov     edx,dstFormatX
DTR_rest1l:
        shadeRawR1
        add     esi,edx
        add     edi,ecx
        dec     eax
        jne     DTR_rest1l
        jmp     DTR_ret

DTR_rest2:
        or      eax,srcSizeY
        je      DTR_ret
        mov     ecx,eax
DTR_rest2l:
        shadeRawR2

        add     esi,rawFormatX
        add     edi,dstFormatX
        dec     ecx
        jne     DTR_rest2l
        jmp     dtr_ret

DTR_rest3:
        or      eax,srcSizeY
        je      DTR_ret
        mov     ecx,eax
DTR_rest3l:
        shadeRawR3

        add     esi,rawFormatX
        add     edi,dstFormatX
        dec     ecx
        jne     DTR_rest3l
        jmp     dtr_ret
DTR_ret:
        ret


_DITH_shadeRaw  ENDP


_DITH_shadeMask    PROC USES esi edi eax ebx ecx edx,
        mask       : dword,
        rawdst     : dword, dstFormatX : dword,
        rawsrc     : dword, srcFormatX : dword,
        srcSizeX   : dword, srcSizeY   : dword

        LOCAL   sizeX : dword

        mov     ecx,srcSizeX
        mov     edx,dstFormatX
        mov     eax,ecx
        and     ecx,0ffffffffh-3
        sub     edx,ecx
        sub     srcFormatX,ecx
        mov     edi,rawdst
        mov     esi,rawsrc
        mov     ebx,mask
        and     ebx,000000FFh
        shl     ebx,8
        je      DTM_ret
        or      ebx,_DITH_shadeBuf
        shr     ecx,2
        mov     sizeX,ecx
        je      DTM_rest

DTM_move:
        and     eax,3
        je      DTM_move0
        dec     eax
        je      DTM_move1
        dec     eax
        je      DTM_move2
        dec     eax
        jmp     DTM_move3

DTM_move0:
        or      eax,srcSizeY
        je      DTM_ret
        cmp     ecx,1
        je      DTM_move4
        mov     dstFormatX,edx
        mov     edx,eax

DTM_move0l:
        lodsd
        mov     bl,al
        mov     al,[ebx]
        mov     bl,ah
        mov     ah,[ebx]
        ror     eax,16
        mov     bl,al
        mov     al,[ebx]
        mov     bl,ah
        mov     ah,[ebx]
        ror     eax,16
        stosd
        loop    DTM_move0l

        add     esi,srcFormatX
        mov     ecx,sizeX
        add     edi,dstFormatX

        dec     edx
        jne     DTM_move0l
        jmp     DTM_ret

DTM_move1:
        or      eax,srcSizeY
        je      DTM_ret
        mov     dstFormatX,edx
        mov     edx,eax
DTM_move1l:
        lodsd
        mov     bl,al
        mov     al,[ebx]
        mov     bl,ah
        mov     ah,[ebx]
        ror     eax,16
        mov     bl,al
        mov     al,[ebx]
        mov     bl,ah
        mov     ah,[ebx]
        ror     eax,16
        stosd
        loop    DTM_move1l
        mov     bl,[esi]
        mov     bl,[ebx]
        mov     es:[edi],bl

        add     esi,srcFormatX
        mov     ecx,sizeX
        add     edi,dstFormatX

        dec     edx
        jne     DTM_move1l
        jmp     DTM_ret

DTM_move2:
        mov     dstFormatX,edx
        or      eax,srcSizeY
        je      DTM_ret
        mov     edx,eax
DTM_move2l:
        lodsd
        mov     bl,al
        mov     al,[ebx]
        mov     bl,ah
        mov     ah,[ebx]
        ror     eax,16
        mov     bl,al
        mov     al,[ebx]
        mov     bl,ah
        mov     ah,[ebx]
        ror     eax,16
        stosd
        loop    DTM_move2l
        mov     eax,[esi]
        mov     bl,al
        mov     al,[ebx]
        mov     bl,ah
        mov     ah,[ebx]
        mov     es:[edi],ax

        add     esi,srcFormatX
        mov     ecx,sizeX
        add     edi,dstFormatX
        dec     edx
        jne     DTM_move2l
        jmp     DTM_ret

DTM_move3:
        mov     dstFormatX,edx
        or      eax,srcSizeY
        je      DTM_ret
        mov     edx,eax
DTM_move3l:
        lodsd
        mov     bl,al
        mov     al,[ebx]
        mov     bl,ah
        mov     ah,[ebx]
        ror     eax,16
        mov     bl,al
        mov     al,[ebx]
        mov     bl,ah
        mov     ah,[ebx]
        ror     eax,16
        stosd
        loop    DTM_move3l

        mov     eax,[esi]
        mov     bl,al
        mov     al,[ebx]
        mov     bl,ah
        mov     ah,[ebx]
        mov     es:[edi],ax
        shr     eax,16
        mov     bl,al
        mov     al,[ebx]
        mov     es:[edi+2],al

        add     esi,srcFormatX
        mov     ecx,sizeX
        add     edi,dstFormatX
        dec     edx
        jne     DTM_move3l
        jmp     DTM_ret

DTM_move4:
        mov     ecx,eax
        push    ebp
        mov     ebp,srcFormatX
        add     ebp,4
        add     edx,4
DTM_move4l:
        mov     eax,[esi]
        mov     bl,al
        mov     al,[ebx]
        mov     bl,ah
        mov     ah,[ebx]
        ror     eax,16
        mov     bl,al
        mov     al,[ebx]
        mov     bl,ah
        mov     ah,[ebx]
        ror     eax,16
        add     esi,ebp
        mov     es:[edi],eax
        add     edi,edx
        dec     ecx
        jne     DTM_move4l
        jmp     DTM_end

DTM_rest:
        and     eax,3
        je      DTM_ret
        dec     eax
        je      DTM_rest1
        dec     eax
        je      DTM_rest2
        dec     eax
        jmp     DTM_rest3

DTM_rest1:
        or      eax,srcSizeY
        je      DTM_ret

        mov     ecx,srcFormatX
DTM_rest1l:
        mov     bl,[esi]
        add     esi,ecx
        mov     bl,[ebx]
        mov     es:[edi],bl
        add     edi,edx
        dec     eax
        jne     DTM_rest1l
        jmp     DTM_ret

DTM_rest2:
        or      eax,srcSizeY
        je      DTM_ret
        push    ebp
        mov     ecx,eax
        mov     ebp,srcFormatX
DTM_rest2l:
        mov     eax,[esi]
        mov     bl,al
        mov     al,[ebx]
        mov     bl,ah
        mov     ah,[ebx]
        mov     es:[edi],ax

        add     esi,ebp
        add     edi,edx
        dec     ecx
        jne     DTM_rest2l
        jmp     DTM_end

DTM_rest3:
        or      eax,srcSizeY
        je      DTM_ret
        push    ebp
        mov     ecx,eax
        mov     ebp,srcFormatX
DTM_rest3l:
        mov     eax,[esi]
        mov     bl,al
        mov     al,[ebx]
        mov     bl,ah
        mov     ah,[ebx]
        mov     es:[edi],ax
        shr     eax,16
        mov     bl,al
        mov     al,[ebx]
        mov     es:[edi+2],al

        add     esi,ebp
        add     edi,edx
        dec     ecx
        jne     DTM_rest3l
        jmp     DTM_end
DTM_end:
        pop     ebp
DTM_ret:
        ret


_DITH_shadeMask  ENDP


_TEXT   ENDS

                END
